 /*
  * Unitex
  *
  * Copyright (C) 2001-2008 Universit� Paris-Est Marne-la-Vall�e <unitex@univ-mlv.fr>
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
  * License as published by the Free Software Foundation; either
  * version 2.1 of the License, or (at your option) any later version.
  *
  * This library is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  * Lesser General Public License for more details.
  * 
  * You should have received a copy of the GNU Lesser General Public
  * License along with this library; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.
  *
  */

#ifndef FrequencyH
#define FrequencyH

#include <Judy.h>
#include "Text_tokens.h"

/*
 * Author: Burak Arslan (arslan@univ-mlv.fr, plq@gsulinux.org)
 *         This File contains the freq api functions and data structures.
 */


/**
 * This structure is used to store information about the current
 * freq build. It is used to avoid giving too much parameters
 * to functions.
 */

typedef struct {
	int automata;
	int words_only;
	int token_limit;
	unsigned threshold;
	int sentence_only;
} freq_opt;

typedef struct {
	unsigned freq;
	int      token;
	unichar* text;	
} freq_entry;

Pvoid_t create_freqtable( struct snt_files *snt, freq_opt option );
int print_freqtable(Pvoid_t freqs, unsigned threshold );


#endif

